var mapArchive = null;
var mapSingle = null
var mapInfoWindow = null;
var mapBounds = null;
var markers = [];

function enoteToggleMap() {
	jQuery("#enote-gmap").toggle();
	jQuery(".enote-list").toggle();
	if (jQuery("#enote-gmap:visible") && jQuery("#enote-gmap").html()=='') {
		initializeEnoteMap();
	}
}

function initializeEnoteMap() {
	mapArchive = new google.maps.Map(document.getElementById('enote-gmap'), {
	  center: {lat: 46.059086, lng: 14.841840},
	  zoom: 8,
	  styles: [
		{
			"featureType": "administrative",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "on"
				},
				{
					"lightness": 33
				}
			]
		},
		{
			"featureType": "landscape",
			"elementType": "all",
			"stylers": [
				{
					"color": "#f7f7f7"
				}
			]
		},
		{
			"featureType": "poi",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "off"
				}
			]
		},
		{
			"featureType": "road",
			"elementType": "all",
			"stylers": [
				{
					"lightness": "25"
				}
			]
		},
		{
			"featureType": "road",
			"elementType": "labels.icon",
			"stylers": [
				{
					"visibility": "off"
				}
			]
		},
		{
			"featureType": "road.highway",
			"elementType": "geometry",
			"stylers": [
				{
					"color": "#ffffff"
				}
			]
		},
		{
			"featureType": "road.highway",
			"elementType": "labels",
			"stylers": [
				{
					"saturation": "-90"
				},
				{
					"lightness": "25"
				}
			]
		},
		{
			"featureType": "road.arterial",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "on"
				}
			]
		},
		{
			"featureType": "road.arterial",
			"elementType": "geometry",
			"stylers": [
				{
					"color": "#ffffff"
				}
			]
		},
		{
			"featureType": "road.local",
			"elementType": "geometry",
			"stylers": [
				{
					"color": "#ffffff"
				}
			]
		},
		{
			"featureType": "transit.line",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "off"
				}
			]
		},
		{
			"featureType": "transit.station",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "off"
				}
			]
		},
		{
			"featureType": "water",
			"elementType": "all",
			"stylers": [
				{
					"visibility": "on"
				},
				{
					"color": "#e0f1f9"
				}
			]
		}
	]
	}); 
	
	jQuery('.enote-list .enota .enota-location-map').each(function() {
		var newLatLng = new google.maps.LatLng(jQuery(this).attr('lat'), jQuery(this).attr('lng'));
		var newMarker = new google.maps.Marker({
			position: newLatLng,
			title:jQuery(this).attr('title')
		});
		newMarker.setIcon('/wp-content/plugins/knjiznice-enote/img/map-'+jQuery(this).attr('markercolor')+'.png');
		
		newMarker['idmarkercontent'] = jQuery(this).attr('idmarkercontent');
		newMarker.addListener('click', function(){
			mapInfoWindow.setContent(jQuery('#'+this.idmarkercontent).html());
			mapInfoWindow.open(mapArchive, this);
		});
		var idreference = jQuery(this).parent().parent().attr('idreference');
		markers[idreference] = newMarker;
		newMarker.setMap(mapArchive);
		mapBounds.extend(newLatLng);

		jQuery(this).remove();
	});
	if (jQuery('#enote-gmap').length && Object.keys(markers).length>1) {
		mapArchive.fitBounds(mapBounds); 
	} else if (jQuery('#enote-gmap').length && Object.keys(markers).length==1) {
		mapArchive.setCenter(markers[Object.keys(markers)[0]].position);
		mapArchive.setZoom(16);
	}
}

jQuery(document).ready(function() {
	mapInfoWindow = new google.maps.InfoWindow({
		maxWidth: 300
	});
	
	mapBounds = new google.maps.LatLngBounds();
	
	if (jQuery('#enote-gmap:visible').length) {
		initializeEnoteMap();
	}

	if (jQuery('#enota-gmap').length) {
		mapSingle = new google.maps.Map(document.getElementById('enota-gmap'), {
		  center: {lat: 46.059086, lng: 14.841840},
		  zoom: 14
		}); 
	}
	
	if (jQuery('.content-map').length && jQuery('#enote-gmap').length && jQuery('#copyright').length) {
		var tempHeight = Math.floor(jQuery(window).height() - jQuery('.content-map').offset().top);
		jQuery('.content-map').css('height', tempHeight+'px');
	}
	
	jQuery('.single-enote .enota-location-map').each(function() {
		var newLatLng = new google.maps.LatLng(jQuery(this).attr('lat'), jQuery(this).attr('lng'));
		var newMarker = new google.maps.Marker({
			position: newLatLng,
			title:jQuery(this).attr('title')
		});
		if (jQuery(this).attr('markercolor')) {
			newMarker.setIcon('/wp-content/plugins/knjiznice-enote/img/map-'+jQuery(this).attr('markercolor')+'.png');
		}
		if (jQuery(this).attr('idmarkercontent')) {
			newMarker['idmarkercontent'] = jQuery(this).attr('idmarkercontent');
			newMarker.addListener('click', function(){
				mapInfoWindow.setContent(jQuery('#'+this.idmarkercontent).html());
				mapInfoWindow.open(mapSingle, this);
			});
			}
		newMarker.setMap(mapSingle);
		markers.push(newMarker);
		mapBounds.extend(newLatLng);
		jQuery(this).remove();
	});
	if (jQuery('.single-enote #enota-gmap').length) {
		if (Object.keys(markers).length>1) {
			mapSingle.fitBounds(mapBounds); 
		}
		else if (Object.keys(markers).length==1) {
			mapSingle.setCenter(markers[Object.keys(markers)[0]].position); 
		}
	}
	

	jQuery('.enota .openhours .currenthours').click(function() {
		jQuery(this).parent().find('.openhourslist').toggle(500);
	});
	
	jQuery('.enote-list .enota').mouseenter(function() {
		if (jQuery("#enote-gmap:visible").length && typeof markers[jQuery(this).attr('idreference')] !== 'undefined') {
			markers[jQuery(this).attr('idreference')].setAnimation(google.maps.Animation.BOUNCE);
		}
	});
	
	jQuery('.enote-list .enota.kml h4 a').click(function() {
		if (jQuery("#enote-gmap:visible").length) {
			var idreference = jQuery(this).parent().parent().parent().attr('idreference');
			mapInfoWindow.setContent(jQuery('#'+markers[idreference].idmarkercontent).html());
			mapInfoWindow.open(mapArchive, markers[idreference]);

		}
		event.preventDefault();
	});
	
	jQuery('.enote-list .enota').mouseleave(function() {
		if (jQuery("#enote-gmap:visible").length && typeof markers[jQuery(this).attr('idreference')] !== 'undefined') {
			markers[jQuery(this).attr('idreference')].setAnimation(null);
		}
	});
	
});